var FdTabLoader = new function() {
    this.isNewTab;
    this.BrowserOpenTab;
    this.URLBarSetURI;
    this.BrowserHome;
    this.BrowserGoHome;
    this.isBlankBrowser;
    this.load = function() {
        loadInExistingTabs();
        gBrowser.addEventListener("load", onPageLoad, true);
        gBrowser.addEventListener("TabOpen", onNewTab, false);
        FdTabLoader.BrowserOpenTab = window.TM_BrowserOpenTab ||
                window.TMP_BrowserOpenTab || window.BrowserOpenTab;
        var Fd_BrowserOpenTab = function() {
            FdTabLoader.isNewTab = true;
            FdTabLoader.BrowserOpenTab();
        }
        if (window.TM_BrowserOpenTab) TM_BrowserOpenTab = Fd_BrowserOpenTab;
        else if (window.TMP_BrowserOpenTab) TMP_BrowserOpenTab = Fd_BrowserOpenTab;
        else BrowserOpenTab = Fd_BrowserOpenTab;
        FdTabLoader.URLBarSetURI = URLBarSetURI;
        URLBarSetURI = function(uri, valid) {
            if (!uri || !FdInfo.matchURI(uri.spec)) {
                return FdTabLoader.URLBarSetURI(uri, valid);
            }
            FdTabLoader.URLBarSetURI(FdURL.getNsiURI("about:blank"));
            SetPageProxyState("valid");
        }
        FdTabLoader.BrowserHome = BrowserHome;
        BrowserHome = function() {
            if (gHomeButton.getHomePage() == "about:blank") {
                FdTabLoader.isNewTab = true;
            }
            FdTabLoader.BrowserHome();
        }
        FdTabLoader.BrowserGoHome = BrowserGoHome;
        BrowserGoHome = function(event) {
            if (gHomeButton.getHomePage() == "about:blank") {
                FdTabLoader.isNewTab = true;
            }
            FdTabLoader.BrowserGoHome(event);
        }
        if (gBrowser.isBlankBrowser) {
            FdTabLoader.isBlankBrowser = gBrowser.isBlankBrowser;
            gBrowser.isBlankBrowser = function(browser) {
                var uri = browser.currentURI;
                return (uri && FdInfo.matchURI(uri.spec)) || FdTabLoader.isBlankBrowser(browser);
            }
        }
    }
    function onNewTab() {
        FdTabLoader.isNewTab = true;
    }

    function isBlank(doc) {
        return doc && doc.location == "about:blank";
    }

    function loadInExistingTabs() {
        var chromehidden = FdDom.get("main-window").getAttribute("chromehidden");
        if (chromehidden.match(/menubar/)) return;
        var tabs = gBrowser.tabContainer.childNodes;
        for (var i = 0; i < tabs.length; i++) {
            var tab = tabs[i];
            if (!tab.hasAttribute("busy") && !tab.hasAttribute("isPermaTab")) {
                var doc = tab.linkedBrowser.contentDocument;
                if (isBlank(doc)) {
                    doc.location = FdInfo.URI
                }
            }
        }
    }

    function onPageLoad(e) {
        var doc = e.originalTarget;
        var tab = FdUtils.getDocumentTab(doc);
        if (!tab) return;
        if (doc.location == FdInfo.URI) {
            FdURL.addToHistory(doc.location, doc.title);
        }
        var singleTab = gBrowser.tabContainer.childNodes.length == 1;
        if ((FdTabLoader.isNewTab || singleTab) && isBlank(doc)) {
            FdTabLoader.isNewTab = false;
            if (FdPrefs.getBool("enable")) {
                doc.location = FdInfo.URI;
            }
        }
    }
}
